Package com.documentum.fc.client

# Interface IDfRelation

All Superinterfaces:
  `IDfPersistentObject`, `IDfTypedObject`

All Known Subinterfaces:
  `IDfStateExtension`

public interface IDfRelation extends IDfPersistentObject
Interface definition for the type dm_relation Description:

- ## Field Summary

  ### Fields inherited from interface com.documentum.fc.client.IDfPersistentObject

  `CURRENCY_CHECK_ALWAYS, CURRENCY_CHECK_FIRST_ACCESS, CURRENCY_CHECK_NEVER, CURRENCY_CHECK_ONCE_PER_SCOPE`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `IDfId`
  `getChildId()`
  Returns the object ID of the child object in the relationship.
  `String`
  `getChildLabel()`
  Returns the version label of the child object in the relationship.
  `String`
  `getDescription()`
  Not system defined.Provided for user convenience.
  `IDfTime`
  `getEffectiveDate()`
  Not system defined.
  `IDfTime`
  `getExpirationDate()`
  Not system defined.
  `int`
  `getOrderNumber()`
  Not system defined.
  `IDfId`
  `getParentId()`
  Returns the object ID of the parent object.
  `boolean`
  `getPermanentLink()`
  Deprecated.
  As of DFC 5.3, replaced by IDfRelationType.getPermanentLink()
  `String`
  `getRelationName()`
  Returns the attribute value of relation_name.
  `void`
  `setChildId(IDfId child)`
  Sets the ID of the object that is the "child" in the relationship.
  `void`
  `setChildLabel(String label)`
  Sets the version label of the child in the relationship.
  `void`
  `setDescription(String desc)`
  Not system defined.
  `void`
  `setEffectiveDate(IDfTime date)`
  Not system defined.
  `void`
  `setExpirationDate(IDfTime date)`
  Not system defined.
  `void`
  `setOrderNumber(int no)`
  Not system defined.
  `void`
  `setParentId(IDfId parent)`
  Sets the ID of the object that is the "parent" in the relationship.
  `void`
  `setPermanentLink(boolean val)`
  Deprecated.
  As of DFC 5.3, replaced by IDfRelationType.setPermanentLink()
  `void`
  `setRelationName(String rName)`
  Sets the relation_name attribute.

  ### Methods inherited from interface com.documentum.fc.client.IDfPersistentObject

  `addChildRelative, addParentRelative, apiExec, apiGet, apiSet, destroy, fetch, fetchWithCaching, getAttrAssistance, getAttrAssistanceWithValues, getAttrAsstDependencies, getChildRelatives, getParentRelatives, getPartition, getType, getValidator, getVStamp, getWidgetType, isDeleted, isDirty, isInstanceOf, isNew, isReplica, lock, lockEx, registerEvent, removeChildRelative, removeParentRelative, revert, save, setPartition, signoff, unRegisterEvent, unRegisterEventEx, validateAllRules, validateAttrRules, validateAttrRulesWithValue, validateAttrRulesWithValues, validateObjRules, validateObjRulesWithValues`

  ### Methods inherited from interface com.documentum.fc.client.IDfTypedObject

  `appendBoolean, appendDouble, appendId, appendInt, appendString, appendTime, appendValue, dump, enumAttrs, findAttrIndex, findBoolean, findDouble, findId, findInt, findString, findTime, findValue, getAllRepeatingStrings, getAttr, getAttrCount, getAttrDataType, getBoolean, getDouble, getId, getInt, getLong, getObjectId, getObjectSession, getOriginalSession, getRepeatingBoolean, getRepeatingDouble, getRepeatingId, getRepeatingInt, getRepeatingLong, getRepeatingString, getRepeatingTime, getRepeatingValue, getSession, getSessionManager, getString, getTime, getValue, getValueAt, getValueCount, hasAttr, insertBoolean, insertDouble, insertId, insertInt, insertString, insertTime, insertValue, isAttrRepeating, isNull, remove, removeAll, setBoolean, setDouble, setId, setInt, setNull, setRepeatingBoolean, setRepeatingDouble, setRepeatingId, setRepeatingInt, setRepeatingString, setRepeatingTime, setRepeatingValue, setSessionManager, setString, setTime, setValue, truncate`

- ## Method Details

  - ### getRelationName

    String getRelationName() throws DfException
    Returns the attribute value of relation_name. The relation name identifies a valid relation type object, which defines the type of relationship existing between the two objects.
    Returns:
      the name of the relation.
    Throws:
      `DfException` - if a server error occurs.

  - ### getParentId

    IDfId getParentId() throws DfException
    Returns the object ID of the parent object. in the relationship.
    Returns:
      the object ID of the parent object.
    Throws:
      `DfException` - if server error occurs.
    See Also:
      - `setParentId(com.documentum.fc.common.IDfId)`

  - ### getChildId

    IDfId getChildId() throws DfException
    Returns the object ID of the child object in the relationship.
    Returns:
      the ID of the child object.
    Throws:
      `DfException` - if server error occurs.
    See Also:
      - `setChildId(com.documentum.fc.common.IDfId)`

  - ### getChildLabel

    String getChildLabel() throws DfException
    Returns the version label of the child object in the relationship.

    The version is not required to be the same version as that specified in child_id. If the object specified in child_id does not carry the correct version label, the server searches the version tree containing the child_id for the version specified in child_label and uses that version in the relationship.
    Returns:
      the version label for the specified child ID.
    Throws:
      `DfException` - if a server error occurs.
    See Also:
      - `setChildLabel(java.lang.String)`

  - ### getPermanentLink

    boolean getPermanentLink() throws DfException
    Deprecated.
    As of DFC 5.3, replaced by IDfRelationType.getPermanentLink()
    Indicates whether you want to maintain the relationship across versions of the parent object.

    By default, relationships are not maintained across versions. However, if you want the relationship to be maintained across versions when the parent object is versioned, set permanent_link via `setPermanentLink` to `true`.

    Returns:
      true if a relationship across versions exists, or `false` if a relationship does not exist.
    Throws:
      `DfException` - if a server error occurs.
    See Also:
      - `setPermanentLink(boolean)`

  - ### getOrderNumber

    int getOrderNumber() throws DfException
    Not system defined. This is provided for user convenience. This could be used to order a set of relationships. Note: Documentum implements and manages system-defined relationships. For user-defined relationships, you must provide the procedures that manage and manipulate the objects in the relationship. Please refer to Server Fundamentals.
    Returns:
      the value of the order_no attribute.
    Throws:
      `DfException` - if a server error occurs.
    See Also:
      - `setOrderNumber(int)`

  - ### getEffectiveDate

    IDfTime getEffectiveDate() throws DfException
    Not system defined. Provided for user convenience. Note: Documentum implements and manages system-defined relationships. For user-defined relationships, you must provide the procedures that manage and manipulate the objects in the relationship. Please refer to Server Fundamentals.
    Returns:
      the value of the effective_date attribute.
    Throws:
      `DfException` - if a server error occurs.
    See Also:
      - `setEffectiveDate(com.documentum.fc.common.IDfTime)`

  - ### getExpirationDate

    IDfTime getExpirationDate() throws DfException
    Not system defined. Provided for user convenience. Note: Documentum implements and manages system-defined relationships. For user-defined relationships, you must provide the procedures that manage and manipulate the objects in the relationship. Please refer to Server Fundamentals.
    Returns:
      the value of the expiration_date attribute.
    Throws:
      `DfException` - if a server error occurs.
    See Also:
      - `setExpirationDate(com.documentum.fc.common.IDfTime)`

  - ### getDescription

    String getDescription() throws DfException
    Not system defined.Provided for user convenience. Note: Documentum implements and manages system-defined relationships. For user-defined relationships, you must provide the procedures that manage and manipulate the objects in the relationship. Please refer to Server Fundamentals.
    Returns:
      the value of the description attribute.
    Throws:
      `DfException` - if a server error occurs.
    See Also:
      - `setDescription(java.lang.String)`

  - ### setRelationName

    void setRelationName(String rName) throws DfException
    Sets the relation_name attribute. The relation name identifies a valid relation type object that defines the type of relationship that exists between the two objects.
    Parameters:
      `rName` - name of the relation.
    Throws:
      `DfException` - if a server error occurs.
    See Also:
      - `getRelationName()`

  - ### setParentId

    void setParentId(IDfId parent) throws DfException
    Sets the ID of the object that is the "parent" in the relationship.
    Parameters:
      `parent` - ID of the parent.
    Throws:
      `DfException` - if a server error occurs.
    See Also:
      - `getParentId()`

  - ### setChildId

    void setChildId(IDfId child) throws DfException
    Sets the ID of the object that is the "child" in the relationship.
    Parameters:
      `child` - ID of the child.
    Throws:
      `DfException` - if a server error occurs.
    See Also:
      - `getChildId()`

  - ### setChildLabel

    void setChildLabel(String label) throws DfException
    Sets the version label of the child in the relationship.

    The version is not required to be the same version as that specified in child_id. If the object specified in child_id does not carry the correct version label, the server searches the version tree containing the child_id for the version specified in child_label and uses that version in the relationship.
    Parameters:
      `label` - label of the child.
    Throws:
      `DfException` - if a server error occurs.
    See Also:
      - `setChildLabel(java.lang.String)`

  - ### setPermanentLink

    void setPermanentLink(boolean val) throws DfException
    Deprecated.
    As of DFC 5.3, replaced by IDfRelationType.setPermanentLink()
    Indicate whether you want to maintain the relationship across versions of the parent object. By default, relationships are not maintained across versions. However, if you want the relationship to be maintained across versions when the parent object is versioned, set permanent_link via `setPermanentLink` to `true`.
    Parameters:
      `val` - value of the permanent_link flag.
    Throws:
      `DfException` - if a server error occurs.
    See Also:
      - `getPermanentLink()`

  - ### setOrderNumber

    void setOrderNumber(int no) throws DfException
    Not system defined. This is provided for user convenience. This could be used to order a set of relationship. Note: Documentum implements and manages system-defined relationships. For user-defined relationships, you must provide the procedures that manage and manipulate the objects in the relationship. Please refer to Server Fundamentals.
    Parameters:
      `no` - order number.
    Throws:
      `DfException` - if a server error occurs.
    See Also:
      - `getOrderNumber()`

  - ### setEffectiveDate

    void setEffectiveDate(IDfTime date) throws DfException
    Not system defined. Provided for user convenience. Note: Documentum implements and manages system-defined relationships. For user-defined relationships, you must provide the procedures that manage and manipulate the objects in the relationship. Please refer to Server Fundamentals.
    Parameters:
      `date` - effective date.
    Throws:
      `DfException` - if a server error occurs.
    See Also:
      - `getEffectiveDate()`

  - ### setExpirationDate

    void setExpirationDate(IDfTime date) throws DfException
    Not system defined. Provided for user convenience. Note: Documentum implements and manages system-defined relationships. For user-defined relationships, you must provide the procedures that manage and manipulate the objects in the relationship. Please refer to Server Fundamentals.
    Parameters:
      `date` - expiration date.
    Throws:
      `DfException` - if a server error occurs.
    See Also:
      - `getExpirationDate()`

  - ### setDescription

    void setDescription(String desc) throws DfException
    Not system defined. Provided for user convenience. Note: Documentum implements and manages system-defined relationships. For user-defined relationships, you must provide the procedures that manage and manipulate the objects in the relationship. Please refer to Server Fundamentals.
    Parameters:
      `desc` - description.
    Throws:
      `DfException` - if a server error occurs.
    See Also:
      - `getDescription()`